; Raster-Split-Hires - 168 * 160 pixels with 8x2 colour-RAM-splits
; only for PAL-VIC 20
; - 21 x Color-RAM-Update = 126 Zyklen
; - 900e Update = 6 Zyklen
; - 900f Update = 6 Zyklen
; - 9002 Update = 4 Zyklen (x and y-register preset)
; = 142 Zyklen (2x71)
;
; $1000 .. $10D1: Bildschirm 1
; $10D2 .. $11B8: Splitscreen-Text 11 Zeilen a 21 Zeichen
; $11B9 .. $11FF: frei (71 Bytes)
; $1200 .. $12D1: Bildschirm 2
; $12D2 .. $12DF: frei (14 Bytes)
; 
; $12E0 .. $1FFF: Zeichen $2E .. $FF (genau 210 Zeichen)
; $2000 .. $2347: Color-RAM (lower  nibble: Zeilen 1,2,5,6,9,10,13,14,...  -> $9600
;                            higher nibble: Zeilen 3,4,7,8,11,12,15,16,... -> $9400 )
; $2348 .. $2397: $900f (80 Bytes)
; $2398 .. $23e7: $900e (80 Bytes)

Operator Calc

LINES   = 312
CYCLES_PER_LINE = 71
TIMER_VALUE     = 22150 ; LINES * CYCLES_PER_LINE - 2

; Set columns and rows;
columns = 25
rows    = 11

total = columns*rows+4096

maxlength       = 87 - (88 mod columns) ; maximum BASIC-line-length
doublerows = rows+rows


*= $a000

; install IRQ and switch to graphics mode (create video-RAM charmap)
        jmp     show
        jmp     copycol

groff
        sei
        jsr     $fd52   ; Initialize I/O-Vectors
        jsr     $fdf9   ; Initialize I/O-Register
        jsr     $e518   ; Initialize Video-Controller
        cli
        rts

show
        lda     #$2e
        tay
strmap  sta     $0fd2,y
        sta     $11d2,y
        clc
        adc     #$0a
        bcc     noadd
        sbc     #$d1
noadd   iny
        bne     strmap
        lda     #$17
        sta     $9001
        jsr     copycol

; Maxi-Edit
        sei
        jsr     LAB_FD52
        jsr     LAB_E518
;blockrestore
;        lda     #$7f
;        sta     $911e
setupirq
        lda     #$86    ; 22150 MOD 256
        sta     $9124
        ldy     #$10
i0      cpy     $9004
        bne     i0
        iny
        iny
i1      cpy     $9004
        bne     i1
        jsr     i6
        iny
        cpy     $9004
        beq     i2
        nop
        nop
i2      jsr     i6
        nop
        iny
        cpy     $9004
        beq     i3
        bit     $24
i3      jsr     i6
        nop
        iny
        cpy     $9004
        bne     i4
i4      ldx     #$06    ; position
i5      dex
        bne     i5
        lda     #$56
        sta     $9125
        cli
        rts

i6      ldx     #$17    ; delay
i7      dex
        bne     i7
        nop
        rts

copycol
        lda     #<l001_002+1
        sta     $fc
        lda     #>l001_002+1
        sta     $fd

        lda     #$28
        sta     $fe     ; Zählvariable für Color-RAM
c0      lda     $fe
        cmp     #$0d    ; für letzten 13*4=52 Zeilen ab $0401
        bne     c00
        lda     #$01
        sta     $fc
        lda     #$04
        sta     $fd
c00     ldx     #$00
c1      lda     $2000,x
        ldy     #$00
        sta     ($fc),y ; $9600-RAM schreiben
        lsr
        lsr
        lsr
        lsr
        ldy     #$76
        sta     ($fc),y ; $9400-RAM schreiben
        clc
        lda     $fc
        adc     #$05
        bcc     c2
        inc     $fd
c2      sta     $fc
        inx
        cpx     #$15
        bne     c1
        txa
        clc
        adc     c1+1
        bcc     c3
        inc     c1+2
c3      sta     c1+1
        clc
        lda     $fc
        adc     #$83
        bcc     c4
        inc     $fd
c4      sta     $fc     
        dec     $fe
        bne     c0
        lda     #$20
        sta     c1+2
        lda     #$00
        sta     c1+1
copyras tax
        lda     #<l001_002+106
        sta     $fc
        lda     #>l001_002+106
        sta     $fd
        lda     $900e
        and     #$0f    ; clear possible aux-color-bit of $900e
        sta     $fe
c5      ldy     #$00
        lda     $2398,x
        and     #$f0    ; nur High-Nibble in $900e übernehmen
        ora     $fe     ; Lautstärke für $900e per OR setzen
        sta     ($fc),y
        ldy     #$05
        lda     $2348,x
        sta     ($fc),y
        clc
        lda     $fc
        adc     #$76
        bcc     c6
        inc     $fd
c6      sta     $fc
        inx
        cpx     #$36
        bne     c7
        lda     #<$0400+106
        sta     $fc
        lda     #>$0400+106
        sta     $fd
c7      cpx     #$50
        bne     c5
        rts

LAB_FD52
        LDX     #<LAB_FD6D              ; pointer to vector table low byte
        LDY     #>LAB_FD6D              ; pointer to vector table high byte
        CLC                             ; flag set vectors
        JMP     $fd57

LAB_FD6D
        word    irq             ; irq          IRQ vector
        word    $FED2           ; LAB_0316      BRK vector
        word    $FEAD           ; LAB_0318      NMI vector
        word    $F40A           ; LAB_031A      open a logical file
        word    $F34A           ; LAB_031C      close a specified logical file
        word    $F2C7           ; LAB_031E      open channel for input
        word    $F309           ; LAB_0320      open channel for output
        word    $F3F3           ; LAB_0322      close input and output channels
        word    LAB_F20E        ; LAB_0324      input character from channel
        word    LAB_F27A        ; LAB_0326      output character to channel
        word    $F770           ; LAB_0328      scan stop key
        word    $F1F5           ; LAB_032A      get character from keyboard queue
        word    $F3EF           ; LAB_032C      close all channels and files
        word    $FED2           ; LAB_032E      user function
        word    $F549           ; LAB_0330      load
        word    $F685           ; LAB_0332      save        

;***********************************************************************************;
;
; NMI handler

LAB_FEAD
        PHA                             ; save A
        TXA                             ; copy X
        PHA                             ; save X
        TYA                             ; copy Y
        PHA                             ; save Y
        LDA     $911D           ; get VIA 1 IFR
        BPL     LAB_FEFF                ; if no interrupt restore registers and exit

        AND     $911E           ; AND with VIA 1 IER
        TAX                             ; copy to X
        AND     #$02                    ; mask [RESTORE] key
        BEQ     LAB_FEDE                ; branch if not [RESTORE] key

                                        ; else was [RESTORE] key ..
        JSR     $FD3F           ; scan for autostart ROM at $A000
        BNE     LAB_FEC7                ; branch if no autostart ROM

        JMP     ($a002)         ; else do autostart ROM break entry

LAB_FEC7
        BIT     $9111           ; test VIA 1 DRA
        JSR     $F734           ; increment the real time clock
        JSR     $FFE1           ; scan stop key
        BNE     LAB_FEFF                ; if not [STOP] restore registers and exit interrupt


;***********************************************************************************;
;
; BRK handler

LAB_FED2
        JSR     LAB_FD52   ; restore default I/O vectors
        JSR     $FDF9           ; initialize I/O registers
        JSR     LAB_E518                ; initialise hardware
        JMP     ($c002)         ; do BASIC break entry

LAB_FEDE
        jmp     $fede

LAB_FEFF
        jmp     $ff56   ; restore registers and exit interrupt
        



;***********************************************************************************;
;
; initialise hardware

LAB_E518
        JSR     LAB_E5BB                ; set default devices and initialise Vic chip
;        LDA     $0288           ; get screen memory page
;        AND     #$FD                    ; mask xxxx xx0x, all but va9
;        ASL                             ; << 1 xxxx x0x0
;        ASL                             ; << 2 xxxx 0x00
;        ORA     #$80                    ; set  1xxx 0x00
;        STA     $9005           ; set screen and character memory location
;        LDA     $0288           ; get screen memory page
;        AND     #$02                    ; mask bit 9
;        BEQ     LAB_E536                ; if zero just go normalise screen
;
;                                        ; else set va9 in vic chip
;        LDA     #$80                    ; set b7
;        ORA     $9002           ; OR in as video address 9
;        STA     $9002           ; save new va9

                                        ; now normalise screen
LAB_E536
        LDA     #$00                    ; clear A
        STA     $0291           ; clear shift mode switch
        STA     $CF             ; clear cursor blink phase
        LDA     #$DC            ; get keyboard decode logic pointer low byte
        STA     $028F           ; set keyboard decode logic pointer low byte
        LDA     #$EB            ; get keyboard decode logic pointer high byte
        STA     $0290           ; set keyboard decode logic pointer high byte
        LDA     #$0A                    ; 10d
        STA     $0289           ; set maximum size of keyboard buffer
        STA     $028C           ; set repeat delay counter
        LDA     #$06                    ; colour blue
        STA     $0286           ; set current colour code
        LDA     #$04                    ; speed 4
        STA     $028B           ; set repeat speed counter
        LDA     #$0C                    ; cursor flash timing
        STA     $CD             ; set cursor timing countdown
        STA     $CC             ; set cursor enable, $00 = flash cursor

; clear screen

LAB_E55F
        LDA     $0288           ; get screen memory page
        ORA     #$80                    ; set high bit, flag every line is logical line start
        TAY                             ; copy to Y
        LDA     #$d2                    ; clear line start low byte
        LDX     #$00                    ; clear index
LAB_E568
        pha
        tya
        STA     LAB_D9,X                   ; save start of line X pointer high byte
        pla
        CLC                             ; clear carry for add
        ADC     #columns                        ; add line length to low byte
        BCC     LAB_E570                ; if no rollover skip the high byte increment

        INY                             ; else increment high byte
LAB_E570
        INX                             ; increment line index
        CPX     #rows+1                      ; compare with number of lines + 1
        BNE     LAB_E568                ; loop if not all done

        LDA     #$FF                    ; end of table marker ??
        STA     LAB_D9,X                   ; mark end of table
        LDX     #rows-1                     ; set line count, 32 lines to do, 0 to 31
LAB_E57B
        JSR     LAB_EA8D                ; clear screen line X
        DEX                             ; decrement count
        BPL     LAB_E57B                ; loop if more to do

; home cursor

LAB_E581
        LDY     #$00                    ; clear Y
        STY     $D3             ; clear cursor column
        STY     $D6             ; clear cursor row

; set screen pointers for cursor row, column

LAB_E587
        LDX     $D6             ; get cursor row
        LDA     $D3             ; get cursor column
LAB_E58B
        LDY     LAB_D9,X                   ; get start of line X pointer high byte
        BMI     LAB_E597                ; continue if logical line start

        CLC                             ; else clear carry for add
        ADC     #columns                        ; add one line length
        STA     $D3             ; save cursor column
        DEX                             ; decrement cursor row
        BPL     LAB_E58B                ; loop, branch always

LAB_E597
        LDA     LAB_D9,X                   ; get start of line X pointer high byte
        AND     #$03                    ; mask 0000 00xx, line memory page
        ORA     $0288           ; OR with screen memory page
        STA     $D2             ; set current screen line pointer high byte
        LDA     LAB_EDFD,X              ; get start of line low byte from ROM table
        STA     $D1             ; set current screen line pointer low byte
        LDA     #columns-1                  ; set line length
        INX                             ; increment cursor row
LAB_E5A8
        LDY     LAB_D9,X                   ; get start of line X pointer high byte
        BMI     LAB_E5B2                ; exit if logical line start

        CLC                             ; else clear carry for add
        ADC     #columns                        ; add one line length to current line length
        INX                             ; increment cursor row
        BPL     LAB_E5A8                ; loop, branch always

LAB_E5B2
        STA     $D5             ; save current screen line length
        RTS


;***********************************************************************************;
;
; set default devices and initialise Vic chip

LAB_E5BB
        LDA     #$03                    ; set screen
        STA     $9A             ; set output device number
        LDA     #$00                    ; set keyboard
        STA     $99             ; set input device number

; initialise Vic chip

;LAB_E5C3
;        LDX     #$10                    ; set byte count
;LAB_E5C5
;        LDA     LAB_EDE3,X      ; get byte from setup table
;        STA     $8fff,X ; save byte to Vic chip
;        DEX                             ; decrement count/index
;        BNE     LAB_E5C5                ; loop if more to do
        RTS

;***********************************************************************************;
;
; write character and wait for key

LAB_E5E5
        JSR     LAB_E742                ; output character

; wait for key from keyboard

LAB_E5E8
        LDA     $C6             ; get keyboard buffer index
        STA     $CC             ; cursor enable, $00 = flash cursor, $xx = no flash
        STA     $0292           ; screen scrolling flag, $00 = scroll, $xx = no scroll
                                        ; this disables both the cursor flash and the screen scroll
                                        ; while there are characters in the keyboard buffer
        BEQ     LAB_E5E8                ; loop if buffer empty

        SEI                             ; disable interrupts
        LDA     $CF             ; get cursor blink phase
        BEQ     LAB_E602                ; branch if cursor phase

                                        ; else character phase
        LDA     $CE             ; get character under cursor
        LDX     $0287           ; get colour under cursor
        LDY     #$00                    ; clear Y
        STY     $CF             ; clear cursor blink phase
        JSR     $EAA1           ; print character A and colour X
LAB_E602
        JSR     $E5CF           ; input from keyboard buffer
        CMP     #$83                    ; compare with [SHIFT][RUN]
        BNE     LAB_E619                ; branch if not [SHIFT][RUN]

                                        ; keys are [SHIFT][RUN] so put "LOAD",$0D,"RUN",$0D into
                                        ; the buffer
        LDX     #$09                    ; set byte count
        SEI                             ; disable interrupts
        STX     $C6             ; set keyboard buffer index
LAB_E60E
        LDA     $EDF3,X         ; get byte from auto load/run table
        STA     $0276,X         ; save to keyboard buffer
        DEX                             ; decrement count/index
        BNE     LAB_E60E                ; loop while more to do

        BEQ     LAB_E5E8                ; loop for next key, branch always

                                        ; was not [SHIFT][RUN]
LAB_E619
        CMP     #$0D                    ; compare with [CR]
        BNE     LAB_E5E5                ; if not [CR] print character and get next key

                                        ; was [CR]
        LDY     $D5             ; get current screen line length
        STY     $D0             ; input from keyboard or screen, $xx = screen,
                                        ; $00 = keyboard
LAB_E621
        LDA     ($D1),Y         ; get character from current screen line
        CMP     #$20                    ; compare with [SPACE]
        BNE     LAB_E62A                ; branch if not [SPACE]

        DEY                             ; else eliminate the space, decrement end of input line
        BNE     LAB_E621                ; loop, branch always

LAB_E62A
        INY                             ; increment past last non space character on line
        STY     $C8             ; save input [EOL] pointer
        LDY     #$00                    ; clear A
        STY     $0292           ; clear screen scrolling flag, $00 = scroll, $xx = no scroll
        STY     $D3             ; clear cursor column
        STY     $D4             ; clear cursor quote flag, $xx = quote, $00 = no quote
        LDA     $C9             ; get input cursor row
        BMI     LAB_E657                ;.

        LDX     $D6             ; get cursor row
        JSR     LAB_E719                ; find and set pointers for start of logical line
        CPX     $C9             ; compare with input cursor row
        BNE     LAB_E657                ;.

        BNE     LAB_E657                ;.?? what's this? just to make sure or something

        LDA     $CA             ; get input cursor column
        STA     $D3             ; save cursor column
        CMP     $C8             ; compare with input [EOL] pointer
        BCC     LAB_E657                ; branch if less, cursor is in line

        BCS     LAB_E691                ; else cursor is beyond the line end, branch always

;***********************************************************************************;
;
; input from screen or keyboard

LAB_E64F
        TYA                             ; copy Y
        PHA                             ; save Y
        TXA                             ; copy X
        PHA                             ; save X
        LDA     $D0             ; input from keyboard or screen, $xx = screen,
                                        ; $00 = keyboard
        BEQ     LAB_E5E8                ; if keyboard go wait for key

LAB_E657
        LDY     $D3             ; get cursor column
        LDA     ($D1),Y         ; get character from the current screen line
        STA     $D7             ; save temporary last character
        AND     #$3F                    ; mask key bits
        ASL     $D7             ; << temporary last character
        BIT     $D7             ; test it
        BPL     LAB_E67E                ; branch if not [NO KEY]

        ORA     #$80                    ;.
LAB_E67E
        BCC     LAB_E684                ;.

        LDX     $D4             ; get cursor quote flag, $xx = quote, $00 = no quote
        BNE     LAB_E688                ; branch if in quote mode

LAB_E684
        BVS     LAB_E688                ;.

        ORA     #$40                    ;.
LAB_E688
        INC     $D3             ; increment cursor column
        JSR     $E6B8           ; if open quote toggle cursor quote flag
        CPY     $C8             ; compare with input [EOL] pointer
        BNE     LAB_E6A8                ; branch if not at line end

LAB_E691
        LDA     #$00                    ;.
        STA     $D0             ; clear input from keyboard or screen, $xx = screen,
                                        ; $00 = keyboard
        LDA     #$0D                    ; set character [CR]
        LDX     $99             ; get input device number
        CPX     #$03                    ; compare with screen
        BEQ     LAB_E6A3                ; branch if screen

        LDX     $9A             ; get output device number
        CPX     #$03                    ; compare with screen
        BEQ     LAB_E6A6                ; branch if screen

LAB_E6A3
        JSR     LAB_E742                ; output character
LAB_E6A6
        LDA     #$0D                    ; set character [CR]
LAB_E6A8
        STA     $D7             ; save character
        PLA                             ; pull X
        TAX                             ; restore X
        PLA                             ; pull Y
        TAY                             ; restore Y
        LDA     $D7             ; restore character
        CMP     #$DE                    ;.
        BNE     LAB_E6B6                ;.

        LDA     #$FF                    ;.
LAB_E6B6
        CLC                             ; flag ok
        RTS

;***********************************************************************************;
;
; insert uppercase/graphic character

LAB_E6C5
        ORA     #$40                    ; change to uppercase/graphic
LAB_E6C7
        LDX     $C7             ; get reverse flag
        BEQ     LAB_E6CD                ; branch if not reverse

                                        ; else ..
; insert reversed character

LAB_E6CB
        ORA     #$80                    ; reverse character
LAB_E6CD
        LDX     $D8                     ; get insert count
        BEQ     LAB_E6D3                ; branch if none

        DEC     $D8             ; else decrement insert count
LAB_E6D3
        LDX     $0286           ; get current colour code
        JSR     $EAA1           ; print character A and colour X
        JSR     LAB_E6EA                ; advance cursor

; restore registers, set quote flag and exit

LAB_E6DC
        PLA                             ; pull Y
        TAY                             ; restore Y
        LDA     $D8                     ; get insert count
        BEQ     LAB_E6E4                ; skip quote flag clear if inserts to do

        LSR     $D4             ; clear cursor quote flag, $xx = quote, $00 = no quote
LAB_E6E4
        PLA                             ; pull X
        TAX                             ; restore X
        PLA                             ; restore A
        CLC                             ;.
        CLI                             ; enable interrupts
        RTS


;***********************************************************************************;
;
; advance cursor

LAB_E6EA
        JSR     LAB_E8FA                ; test for line increment
        INC     $D3             ; increment cursor column
        LDA     $D5             ; get current screen line length
        CMP     $D3             ; compare with cursor column
        BCS     LAB_E72C                ; exit if line length >= cursor column

        CMP     #maxlength                      ; compare with max length
        BEQ     LAB_E723                ; if at max clear column, back cursor up and do newline

        LDA     $0292           ; get autoscroll flag
        BEQ     LAB_E701                ; branch if autoscroll on

        JMP     LAB_E9F0                ;.else open space on screen

LAB_E701
        LDX     $D6             ; get cursor row
        CPX     #rows                   ; compare with max + 1
        BCC     LAB_E70E                ; if less than max + 1 go add this row to the current
                                        ; logical line

        JSR     LAB_E975                ; else scroll screen
        DEC     $D6             ; decrement cursor row
        LDX     $D6             ; get cursor row

; add this row to the current logical line

LAB_E70E
        ASL     LAB_D9,X                   ; shift start of line X pointer high byte
        LSR     LAB_D9,X                   ; shift start of line X pointer high byte back,
                                        ; clear b7, start of logical line
; make next screen line start of logical line, increment line length and set pointers
        INX                             ; increment screen row
        LDA     LAB_D9,X                  ; get start of line X pointer high byte
        ORA     #$80                    ; mark as start of logical line
        STA     LAB_D9,X                   ; set start of line X pointer high byte
        DEX                             ; restore screen row
        LDA     $D5             ; get current screen line length
        CLC                             ; clear carry for add
; add one line length and set pointers for start of line
        ADC     #columns                        ; add one line length
        STA     $D5             ; save current screen line length

; find and set pointers for start of logical line

LAB_E719
        LDA     LAB_D9,X                   ; get start of line X pointer high byte
        BMI     LAB_E720                ; exit loop if start of logical line

        DEX                             ; else back up one line
        BNE     LAB_E719                ; loop if not on first line

LAB_E720
        JMP     LAB_EA7E                ; set start of line X and return

; clear cursor column, back cursor up one line and do newline

LAB_E723
        DEC     $D6             ; decrement cursor row. if the cursor was incremented past
                                        ; the last line then this decrement and the scroll will
                                        ; leave the cursor one line above the botom of the screen
        JSR     LAB_E8C3                ; do newline
        LDA     #$00                    ; clear A
        STA     $D3             ; clear cursor column
LAB_E72C
        RTS

; back onto previous line if possible

LAB_E72D
        LDX     $D6             ; get cursor row
        BNE     LAB_E737                ; branch if not top row

        STX     $D3             ; clear cursor column
        PLA                             ; dump return address low byte
        PLA                             ; dump return address high byte
        BNE     LAB_E6DC                ; restore registers, set quote flag and exit, branch always

LAB_E737
        DEX                             ; decrement cursor row
        STX     $D6             ; save cursor row
        JSR     LAB_E587                ; set screen pointers for cursor row, column
        LDY     $D5             ; get current screen line length
        STY     $D3             ; save as cursor column
        RTS


;***********************************************************************************;
;
;## output character to screen

LAB_E742
        PHA                             ; save character
        STA     $D7             ; save temporary last character
        TXA                             ; copy X
        PHA                             ; save X
        TYA                             ; copy Y
        PHA                             ; save Y
        LDA     #$00                    ; clear A
        STA     $D0             ; clear input from keyboard or screen, $xx = screen,
                                        ; $00 = keyboard
        LDY     $D3             ; get cursor column
        LDA     $D7             ; restore last character
        BPL     LAB_E756                ; branch if unshifted

        JMP     LAB_E800                ; do shifted characters and return

LAB_E756
        CMP     #$0D                    ; compare with [CR]
        BNE     LAB_E75D                ; branch if not [CR]

        JMP     LAB_E8D8                ; else output [CR] and return

LAB_E75D
        CMP     #$20                    ; compare with [SPACE]
        BCC     LAB_E771                ; branch if < [SPACE]

        CMP     #$60                    ;.
        BCC     LAB_E769                ; branch if $20 to $5F

                                        ; character is $60 or greater
        AND     #$DF                    ;.
        BNE     LAB_E76B                ;.

LAB_E769
        AND     #$3F                    ;.
LAB_E76B
        JSR     $E6B8           ; if open quote toggle cursor direct/programmed flag
        JMP     LAB_E6C7                ;.

                                        ; character was < [SPACE] so is a control character
                                        ; of some sort
LAB_E771
        LDX     $D8                     ; get insert count
        BEQ     LAB_E778                ; branch if no characters to insert

        JMP     LAB_E6CB                ; insert reversed character

LAB_E778
        CMP     #$14                    ; compare with [INSERT]/[DELETE]
        BNE     LAB_E7AA                ; branch if not [INSERT]/[DELETE]

        TYA                             ;.
        BNE     LAB_E785                ;.

        JSR     LAB_E72D                ; back onto previous line if possible
        JMP     LAB_E79F                ;.

LAB_E785
        JSR     LAB_E8E8                ; test for line decrement

                                        ; now close up the line
        DEY                             ; decrement index to previous character
        STY     $D3             ; save cursor column
        JSR     $EAB2           ; calculate pointer to colour RAM
LAB_E78E
        INY                             ; increment index to next character
        LDA     ($D1),Y         ; get character from current screen line
        DEY                             ; decrement index to previous character
        STA     ($D1),Y         ; save character to current screen line
        INY                             ; increment index to next character
        LDA     ($F3),Y         ; get colour RAM byte
        DEY                             ; decrement index to previous character
        STA     ($F3),Y         ; save colour RAM byte
        INY                             ; increment index to next character
        CPY     $D5             ; compare with current screen line length
        BNE     LAB_E78E                ; loop if not there yet

LAB_E79F
        LDA     #$20                    ; set [SPACE]
        STA     ($D1),Y         ; clear last character on current screen line
        LDA     $0286           ; get current colour code
        STA     ($F3),Y         ; save to colour RAM
        BPL     LAB_E7F7                ; branch always

LAB_E7AA
        LDX     $D4             ; get cursor quote flag, $xx = quote, $00 = no quote
        BEQ     LAB_E7B1                ; branch if not quote mode

        JMP     LAB_E6CB                ; insert reversed character

LAB_E7B1
        CMP     #$12                    ; compare with [RVS ON]
        BNE     LAB_E7B7                ; branch if not [RVS ON]

        STA     $C7             ; set reverse flag
LAB_E7B7
        CMP     #$13                    ; compare with [CLR HOME]
        BNE     LAB_E7BE                ; branch if not [CLR HOME]

        JSR     LAB_E581                ; home cursor
LAB_E7BE
        CMP     #$1D                    ; compare with [CURSOR RIGHT]
        BNE     LAB_E7D9                ; branch if not [CURSOR RIGHT]

        INY                             ; increment cursor column
        JSR     LAB_E8FA                ; test for line increment
        STY     $D3             ; save cursor column
        DEY                             ; decrement cursor column
        CPY     $D5             ; compare cursor column with current screen line length
        BCC     LAB_E7D6                ; exit if less

                                        ; else the cursor column is >= the current screen line
                                        ; length so back onto the current line and do a newline
        DEC     $D6             ; decrement cursor row
        JSR     LAB_E8C3                ; do newline
        LDY     #$00                    ; clear cursor column
LAB_E7D4
        STY     $D3             ; save cursor column
LAB_E7D6
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit

LAB_E7D9
        CMP     #$11                    ; compare with [CURSOR DOWN]
        BNE     LAB_E7FA                ; branch if not [CURSOR DOWN]

        CLC                             ; clear carry for add
        TYA                             ; copy cursor column
        ADC     #columns                        ; add one line
        TAY                             ; copy back to A
        INC     $D6             ; increment cursor row
        CMP     $D5             ; compare cursor column with current screen line length
        BCC     LAB_E7D4                ; save cursor column and exit if less

        BEQ     LAB_E7D4                ; save cursor column and exit if equal

                                        ; else the cursor has moved beyond the end of this line
                                        ; so back it up until it's on the start of the logical line
        DEC     $D6             ; decrement cursor row
LAB_E7EC
        SBC     #columns                        ; subtract one line
        BCC     LAB_E7F4                ; exit loop if on previous line

        STA     $D3             ; else save cursor column
        BNE     LAB_E7EC                ; loop if not at start of line

LAB_E7F4
        JSR     LAB_E8C3                ; do newline
LAB_E7F7
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit

LAB_E7FA
        JSR     $E912           ; set the colour from the character in A
        JMP     $ED21           ;.

LAB_E800
        AND     #$7F                    ; mask 0xxx xxxx, clear b7
        CMP     #$7F                    ; was it $FF before the mask
        BNE     LAB_E81D                ; branch if not

        LDA     #$5E                    ; else make it $5E
LAB_E81D
        CMP     #$20                    ; compare with [SPACE]
        BCC     LAB_E82A                ; branch if < [SPACE]

        JMP     LAB_E6C5                ; insert uppercase/graphic character and return

                                        ; character was $80 to $9F and is now $00 to $1F
LAB_E82A
        CMP     #$0D                    ; compare with [CR]
        BNE     LAB_E831                ; branch if not [CR]

        JMP     LAB_E8D8                ; else output [CR] and return

                                        ; was not [CR]
LAB_E831
        LDX     $D4             ; get cursor quote flag, $xx = quote, $00 = no quote
        BNE     LAB_E874                ; branch if quote mode

        CMP     #$14                    ; compare with [INSERT DELETE]
        BNE     LAB_E870                ; branch if not [INSERT DELETE]

        LDY     $D5             ; get current screen line length
        LDA     ($D1),Y         ; get character from current screen line
        CMP     #$20                    ; compare with [SPACE]
        BNE     LAB_E845                ; branch if not [SPACE]

        CPY     $D3             ; compare current column with cursor column
        BNE     LAB_E84C                ; if not cursor column go open up space on line

LAB_E845
        CPY     #maxlength              ; compare current column with max line length
        BEQ     LAB_E86D                ; exit if at line end

        JSR     LAB_E9EE                ; else open space on screen
                                        ; now open up space on the line to insert a character
LAB_E84C
        LDY     $D5             ; get current screen line length
        JSR     $EAB2           ; calculate pointer to colour RAM
LAB_E851
        DEY                             ; decrement index to previous character
        LDA     ($D1),Y         ; get character from current screen line
        INY                             ; increment index to next character
        STA     ($D1),Y         ; save character to current screen line
        DEY                             ; decrement index to previous character
        LDA     ($F3),Y         ; get current screen line colour RAM byte
        INY                             ; increment index to next character
        STA     ($F3),Y         ; save current screen line colour RAM byte
        DEY                             ; decrement index to previous character
        CPY     $D3             ; compare with cursor column
        BNE     LAB_E851                ; loop if not there yet

        LDA     #$20            ; set [SPACE]
        STA     ($D1),Y         ; clear character at cursor position on current screen line
        LDA     $0286           ; get current colour code
        STA     ($F3),Y         ; save to cursor position on current screen line colour RAM
        INC     $D8             ; increment insert count
LAB_E86D
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit

LAB_E870
        LDX     $D8                     ; get insert count
        BEQ     LAB_E879                ; branch if no insert space

LAB_E874
        ORA     #$40                    ; change to uppercase/graphic
        JMP     LAB_E6CB                ; insert reversed character

LAB_E879
        CMP     #$11                    ; compare with [CURSOR UP]
        BNE     LAB_E893                ; branch if not [CURSOR UP]

        LDX     $D6             ; get cursor row
        BEQ     LAB_E8B8                ; branch if on top line

        DEC     $D6             ; decrement cursor row
        LDA     $D3             ; get cursor column
        SEC                             ; set carry for subtract
        SBC     #columns                        ; subtract one line length
        BCC     LAB_E88E                ; branch if stepped back to previous line

        STA     $D3             ; else save cursor column ..
        BPL     LAB_E8B8                ; .. and exit, branch always

LAB_E88E
        JSR     LAB_E587                ; set screen pointers for cursor row, column ..
        BNE     LAB_E8B8                ; .. and exit, branch always

LAB_E893
        CMP     #$12                    ; compare with [RVS OFF]
        BNE     LAB_E89B                ; branch if not [RVS OFF]

        LDA     #$00                    ; clear A
        STA     $C7             ; clear reverse flag
LAB_E89B
        CMP     #$1D                    ; compare with [CURSOR LEFT]
        BNE     LAB_E8B1                ; branch if not [CURSOR LEFT]

        TYA                             ; copy cursor column
        BEQ     LAB_E8AB                ; branch if at start of line

        JSR     LAB_E8E8                ; test for line decrement
        DEY                             ; decrement cursor column
        STY     $D3             ; save cursor column
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit

LAB_E8AB
        JSR     LAB_E72D                ; back onto previous line if possible
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit

LAB_E8B1
        CMP     #$13                    ; compare with [CLR]
        BNE     LAB_E8BB                ; branch if not [CLR]

        JSR     LAB_E55F                ; clear screen
LAB_E8B8
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit

LAB_E8BB
        ORA     #$80                    ; restore b7, colour can only be black, cyan, magenta
                                        ; or yellow
        JSR     $E912           ; set the colour from the character in A
        JMP     $ED30           ;.

;***********************************************************************************;
;
; do newline

LAB_E8C3
        LSR     $C9             ; shift >> input cursor row
        LDX     $D6             ; get cursor row
LAB_E8C7
        INX                             ; increment row
        CPX     #rows                   ; compare with last row + 1
        BNE     LAB_E8CF                ; branch if not last row + 1

        JSR     LAB_E975                ; else scroll screen
LAB_E8CF
        LDA     LAB_D9,X                   ; get start of line X pointer high byte
        BPL     LAB_E8C7                ; loop if not start of logical line

        STX     $D6             ; else save cursor row
        JMP     LAB_E587                ; set screen pointers for cursor row, column and return


;***********************************************************************************;
;
; output [CR]

LAB_E8D8
        LDX     #$00                    ; clear X
        STX     $D8             ; clear insert count
        STX     $C7             ; clear reverse flag
        STX     $D4             ; clear cursor quote flag, $xx = quote, $00 = no quote
        STX     $D3             ; clear cursor column
        JSR     LAB_E8C3                ; do newline
        JMP     LAB_E6DC                ; restore registers, set quote flag and exit


;***********************************************************************************;
;
; test for line decrement

LAB_E8E8
        LDX     #$04                    ; set count
        LDA     #$00                    ; set column
LAB_E8EC
        CMP     $D3             ; compare with cursor column
        BEQ     LAB_E8F7                ; branch if at start of line

        CLC                             ; else clear carry for add
        ADC     #columns                        ; increment to next line
        DEX                             ; decrement loop count
        BNE     LAB_E8EC                ; loop if more to test

        RTS

LAB_E8F7
        DEC     $D6             ; else decrement cursor row
        RTS


;***********************************************************************************;
;
; test for line increment. if at end of line, but not at end of last line, increment the
; cursor row

LAB_E8FA
        LDX     #$04                    ; set count
        LDA     #columns-1                  ; set column
LAB_E8FE
        CMP     $D3             ; compare with cursor column
        BEQ     LAB_E909                ; if at end of line test and possibly increment cursor row

        CLC                             ; else clear carry for add
        ADC     #columns                        ; increment to next line
        DEX                             ; decrement loop count
        BNE     LAB_E8FE                ; loop if more to test

        RTS

                                        ; cursor is at end of line
LAB_E909
        LDX     $D6             ; get cursor row
        CPX     #rows                   ; compare with end of screen
        BEQ     LAB_E911                ; exit if end of screen

        INC     $D6             ; else increment cursor row
LAB_E911
        RTS

;***********************************************************************************;
;
; scroll screen

LAB_E975
        LDA     $AC             ; copy tape buffer start pointer
        PHA                             ; save it
        LDA     $AD             ; copy tape buffer start pointer
        PHA                             ; save it
        LDA     $AE             ; copy tape buffer end pointer
        PHA                             ; save it
        LDA     $AF             ; copy tape buffer end pointer
        PHA                             ; save it
LAB_E981
        LDX     #$FF                    ; set to -1 for pre increment loop
        DEC     $D6             ; decrement cursor row
        DEC     $C9             ; decrement input cursor row
        DEC     $F2             ; decrement screen row marker
LAB_E989
        INX                             ; increment line number
        JSR     LAB_EA7E                ; set start of line X
        CPX     #rows-1                     ; compare with last line
        BCS     LAB_E99D                ; branch if >= rows-1

        LDA     LAB_EDFD+1,X ; get start of next line pointer low byte
        STA     $AC             ; save next line pointer low byte
        LDA     LAB_D9+1,X              ; get start of next line pointer high byte
        JSR     LAB_EA56                ; shift screen line up
        BMI     LAB_E989                ; loop, branch always

LAB_E99D
        JSR     LAB_EA8D                ; clear screen line X

                                        ; now shift up the start of logical line bits
        LDX     #$00                    ; clear index
LAB_E9A2
        LDA     LAB_D9,X                   ; get start of line X pointer high byte
        AND     #$7F                    ; clear line X start of logical line bit
        LDY     LAB_D9+1,X              ; get start of next line pointer high byte
        BPL     LAB_E9AC                ; branch if next line not start of line

        ORA     #$80                    ; set line X start of logical line bit
LAB_E9AC
        STA     LAB_D9,X                   ; set start of line X pointer high byte
        INX                             ; increment line number
        CPX     #rows-1                     ; compare with last line
        BNE     LAB_E9A2                ; loop if not last line

        LDA     LAB_D9MINUS1+rows       ; get start of last line pointer high byte
        ORA     #$80                    ; mark as start of logical line
        STA     LAB_D9MINUS1+rows       ; set start of last line pointer high byte
        LDA     LAB_D9          ; get start of first line pointer high byte
        BPL     LAB_E981                ; if not start of logical line loop back and
                                        ; scroll the screen up another line

        INC     $D6             ; increment cursor row
        INC     $F2             ; increment screen row marker
        LDA     #$FB                    ; set keyboard column c2
        STA     $9120           ; set VIA 2 DRB, keyboard column
        LDA     $9121           ; get VIA 2 DRA, keyboard row
        CMP     #$FE                    ; compare with row r0 active, [CTL]
        PHP                             ; save status
        LDA     #$F7                    ; set keyboard column c3
        STA     $9120           ; set VIA 2 DRB, keyboard column
        PLP                             ; restore status
        BNE     LAB_E9DF                ; skip delay if ??

                                        ; first time round the inner loop X will be $16
        LDY     #$00                    ; clear delay outer loop count, do this 256 times
LAB_E9D6
        NOP                             ; waste cycles
        DEX                             ; decrement inner loop count
        BNE     LAB_E9D6                ; loop if not all done

        DEY                             ; decrement outer loop count
        BNE     LAB_E9D6                ; loop if not all done

        STY     $C6             ; clear keyboard buffer index
LAB_E9DF
        LDX     $D6             ; get cursor row
        PLA                             ; pull tape buffer end pointer
        STA     $AF             ; restore it
        PLA                             ; pull tape buffer end pointer
        STA     $AE             ; restore it
        PLA                             ; pull tape buffer pointer
        STA     $AD             ; restore it
        PLA                             ; pull tape buffer pointer
        STA     $AC             ; restore it
        RTS


;***********************************************************************************;
;
; open space on screen

LAB_E9EE
        LDX     $D6             ; get cursor row
LAB_E9F0
        INX                             ; increment row
        LDA     LAB_D9,X                  ; get start of line X pointer high byte
        BPL     LAB_E9F0                ; branch if not start of logical line

        STX     $F2             ; set screen row marker
        CPX     #rows-1                     ; compare with last line
        BEQ     LAB_EA08                ; branch if = last line

        BCC     LAB_EA08                ; branch if < last line

                                        ; else was > last line
        JSR     LAB_E975                ; else scroll screen
        LDX     $F2             ; get screen row marker
        DEX                             ; decrement screen row marker
        DEC     $D6             ; decrement cursor row
        JMP     LAB_E70E                ; add this row to the current logical line and return

LAB_EA08
        LDA     $AC             ; copy tape buffer pointer
        PHA                             ; save it
        LDA     $AD             ; copy tape buffer pointer
        PHA                             ; save it
        LDA     $AE             ; copy tape buffer end pointer
        PHA                             ; save it
        LDA     $AF             ; copy tape buffer end pointer
        PHA                             ; save it
        LDX     #rows                   ; set to end line + 1 for predecrement loop
LAB_EA16
        DEX                             ; decrement line number
        JSR     LAB_EA7E                ; set start of line X
        CPX     $F2             ; compare with screen row marker
        BCC     LAB_EA2C                ; branch if < screen row marker

        BEQ     LAB_EA2C                ; branch if = screen row marker

        LDA     LAB_EDFD-1,X        ; else get start of previous line low byte from ROM table
        STA     $AC             ; save previous line pointer low byte
        LDA     LAB_D9-1,X          ; get start of previous line pointer high byte
        JSR     LAB_EA56                ; shift screen line down
        BMI     LAB_EA16                ; loop, branch always

LAB_EA2C
        JSR     LAB_EA8D                ; clear screen line X
        LDX     #columns-1                  ;.
LAB_EA31
        CPX     $F2             ;.compare with screen row marker
        BCC     LAB_EA44                ;.

        LDA     LAB_D9+1,X             ;.
        AND     #$7F                    ;.
        LDY     LAB_D9,X                   ; get start of line X pointer high byte
        BPL     LAB_EA3F                ;.

        ORA     #$80                    ;.
LAB_EA3F
        STA     LAB_D9+1,X                 ;.
        DEX                             ;.
        BNE     LAB_EA31                ;.

LAB_EA44
        LDX     $F2             ;.get screen row marker
        JSR     LAB_E70E                ; add this row to the current logical line
        PLA                             ; pull tape buffer end pointer
        STA     $AF             ; restore it
        PLA                             ; pull tape buffer end pointer
        STA     $AE             ; restore it
        PLA                             ; pull tape buffer pointer
        STA     $AD             ; restore it
        PLA                             ; pull tape buffer pointer
        STA     $AC             ; restore it
        RTS


;***********************************************************************************;
;
; shift screen line up/down

LAB_EA56
        AND     #$03                    ; mask 0000 00xx, line memory page
        ORA     $0288           ; OR with screen memory page
        STA     $AD             ; save next/previous line pointer high byte
        JSR     $EA6E           ; calculate pointers to screen lines colour RAM
LAB_EA60
        LDY     #columns-1                  ; set column count
LAB_EA62
        LDA     ($AC),Y         ; get character from next/previous screen line
        STA     ($D1),Y         ; save character to current screen line
        LDA     ($AE),Y         ; get colour from next/previous screen line colour RAM
        STA     ($F3),Y         ; save colour to current screen line colour RAM
        DEY                             ; decrement column index/count
        BPL     LAB_EA62                ; loop if more to do

        RTS

;***********************************************************************************;
;
; set start of line X

LAB_EA7E
        LDA     LAB_EDFD,X              ; get start of line low byte from ROM table
        STA     $D1             ; set current screen line pointer low byte
        LDA     LAB_D9,X                   ; get start of line high byte from RAM table
        AND     #$03                    ; mask 0000 00xx, line memory page
        ORA     $0288           ; OR with screen memory page
        STA     $D2             ; set current screen line pointer high byte
        RTS

;***********************************************************************************;
;
; clear screen line X

LAB_EA8D
        LDY     #columns-1                  ; set number of columns to clear
        JSR     LAB_EA7E                ; set start of line X
        JSR     $EAB2           ; calculate pointer to colour RAM
LAB_EA95
        LDA     #$20                    ; set [SPACE]
        STA     ($D1),Y         ; clear character in current screen line
        LDA     #$01                    ; set colour, blue on white
        STA     ($F3),Y         ; set colour RAM in current screen line
        DEY                             ; decrement index
        BPL     LAB_EA95                ; loop if more to do

LAB_EDE3        RTS

LAB_EDE4
;       byte    34-columns                     ; interlace and horizontal center [PAL]
;       byte    85-doublerows                    ; vertical origin [PAL]
;       byte    columns                     ; video address and colums, $9400 for colour RAM
;                                        ; bit   function
;                                        ; ---   --------
;                                        ;  7    video address va9
;                                        ; 6-0   number of columns
;       byte    2*rows                     ; rows and character size
;                                        ; bit   function
;                                        ; ---   --------
;                                        ;  7    b9 raster line
;                                        ; 6-1   number of rows
;                                        ;  0    8x16 / 8x8 characters
;       byte    $00                     ; raster line
;       byte    $C0                     ; video memory addresses, RAM $1000, ROM $8000
,                                        ; bit   function
;                                        ; ---   --------
;                                        ;  7    must be 1
;                                        ; 6-4   video memory address va12-va10
;                                        ; 3-0   character memory start address
;
                                        ; 0000 ROM      $8000   set 1 - we use this
                                        ; 0001  "       $8400
                                        ; 0010  "       $8800 set 2
                                        ; 0011  "       $8C00
                                        ; 1100 RAM      $1000
                                        ; 1101  "       $1400
                                        ; 1110  "       $1800
                                        ; 1111  "       $1C00

;       byte    $00                     ; light pen horizontal position
;       byte    $00                     ; light pen vertical position

;       byte    $00                     ; paddle X
;       byte    $00                     ; paddle Y
;       byte    $00                     ; oscillator 1 frequency
;       byte    $00                     ; oscillator 2 frequency
;       byte    $00                     ; oscillator 3 frequency
;       byte    $00                     ; noise source frequency
;       byte    $00                     ; aux colour and volume
                                        ; bit   function
                                        ; ---   --------
                                        ; 7-4   auxiliary colour information
                                        ; 3-0   volume
;       byte    $1B                     ; screen and border colour
                                        ; bit   function
                                        ; ---   --------
                                        ; 7-4   background colour
                                        ;  3    inverted or normal mode
                                        ; 2-0   border colour

;***********************************************************************************;
;
; low byte screen line addresses

LAB_EDFD
       byte    210,235,4,29
       byte    54,79,104,129
       byte    154,179,204,229

LAB_D9MINUS1    byte    254

LAB_D9
       byte    $00,$00,$00,$00,$00,$00,$00,$00
       byte    $00,$00,$00,$00,$00,$00,$00,$00
       byte    $00,$00,$00,$00,$00,$00,$00,$00

       byte    $00,$00,$00

;***********************************************************************************;
;
; CHRIN

LAB_F20E
        LDA     $99             ; get input device number
        BNE     LAB_F21D                ; if it's not the keyboard continue

                                        ; the input device is the keyboard
        LDA     $D3             ; get cursor column
        STA     $CA             ; set input cursor column
        LDA     $D6             ; get cursor row
        STA     $C9             ; set input cursor row
        JMP     LAB_E64F                ; go get input from the keyboard

; the input device was not the keyboard

LAB_F21D
        CMP     #$03                    ; compare device number with screen
        BNE     LAB_F22A                ; if it's not the screen continue

                                        ; the input device is the screen
        STA     $D0             ; input from keyboard or screen, $xx = screen,
                                        ; $00 = keyboard
        LDA     $D5             ; get current screen line length
        STA     $C8             ; save input [EOL] pointer
        JMP     LAB_E64F                ; go get input from the screen

; the input device was not the screen

LAB_F22A
        JMP     $f2aa

;***********************************************************************************;
;
; CHROUT

LAB_F27A
        PHA                             ; save the character to send
        LDA     $9A             ; get output device number
        CMP     #$03                    ; compare device number with screen
        BNE     LAB_F285                ; if output device not screen continue

; the output device is the screen

        PLA                             ; restore character to send
        JMP     LAB_E742                ; output character and return

; the output device was not the screen

LAB_F285
        JMP     $f285

irq     cld
        sec
        lda     #$58
        sbc     $9124
        cmp     #$0a
        bcc     s0
        jmp     $eabf
s0      sta     s1+1
s1      bcc     s1
        lda     #$a9
        lda     #$a9
        lda     #$a9
        lda     #$a9
        lda     #$a5
        nop
                
gron    ldx     #$95
        ldy     #$15
        sty     $9002
        sty     $9003
        lda     #$0d
        sta     $9000
        lda     $9005
        pha
        lda     $900f
        pha
        lda     #$cc
        sta     $9005
l001_002
        lda     #$00
        sta     $9600
        lda     #$00
        sta     $9601
        lda     #$00
        sta     $9602
        lda     #$00
        sta     $9603
        lda     #$00
        sta     $9604
        lda     #$00
        sta     $9605
        lda     #$00
        sta     $9606
        lda     #$00
        sta     $9607
        lda     #$00
        sta     $9608
        lda     #$00
        sta     $9609
        lda     #$00
        sta     $960a
        lda     #$00
        sta     $960b
        lda     #$00
        sta     $960c
        lda     #$00
        sta     $960d
        lda     #$00
        sta     $960e
        lda     #$00
        sta     $960f
        lda     #$00
        sta     $9610
        lda     #$00
        sta     $9611
        lda     #$00
        sta     $9612
        lda     #$00
        sta     $9613
        lda     #$00
        sta     $9614
        lda     #$00
        sta     $900e
        lda     #$1c
        sta     $900f
        stx     $9002
        
l003_004        
        lda     #$00
        sta     $9400
        lda     #$00
        sta     $9401
        lda     #$00
        sta     $9402
        lda     #$00
        sta     $9403
        lda     #$00
        sta     $9404
        lda     #$00
        sta     $9405
        lda     #$00
        sta     $9406
        lda     #$00
        sta     $9407
        lda     #$00
        sta     $9408
        lda     #$00
        sta     $9409
        lda     #$00
        sta     $940a
        lda     #$00
        sta     $940b
        lda     #$00
        sta     $940c
        lda     #$00
        sta     $940d
        lda     #$00
        sta     $940e
        lda     #$00
        sta     $940f
        lda     #$00
        sta     $9410
        lda     #$00
        sta     $9411
        lda     #$00
        sta     $9412
        lda     #$00
        sta     $9413
        lda     #$00
        sta     $9414
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l005_006        
        lda     #$00
        sta     $9600
        lda     #$00
        sta     $9601
        lda     #$00
        sta     $9602
        lda     #$00
        sta     $9603
        lda     #$00
        sta     $9604
        lda     #$00
        sta     $9605
        lda     #$00
        sta     $9606
        lda     #$00
        sta     $9607
        lda     #$00
        sta     $9608
        lda     #$00
        sta     $9609
        lda     #$00
        sta     $960a
        lda     #$00
        sta     $960b
        lda     #$00
        sta     $960c
        lda     #$00
        sta     $960d
        lda     #$00
        sta     $960e
        lda     #$00
        sta     $960f
        lda     #$00
        sta     $9610
        lda     #$00
        sta     $9611
        lda     #$00
        sta     $9612
        lda     #$00
        sta     $9613
        lda     #$00
        sta     $9614
        lda     #$00
        sta     $900e
        lda     #$1c
        sta     $900f
        stx     $9002
        
l007_008        
        lda     #$00
        sta     $9400
        lda     #$00
        sta     $9401
        lda     #$00
        sta     $9402
        lda     #$00
        sta     $9403
        lda     #$00
        sta     $9404
        lda     #$00
        sta     $9405
        lda     #$00
        sta     $9406
        lda     #$00
        sta     $9407
        lda     #$00
        sta     $9408
        lda     #$00
        sta     $9409
        lda     #$00
        sta     $940a
        lda     #$00
        sta     $940b
        lda     #$00
        sta     $940c
        lda     #$00
        sta     $940d
        lda     #$00
        sta     $940e
        lda     #$00
        sta     $940f
        lda     #$00
        sta     $9410
        lda     #$00
        sta     $9411
        lda     #$00
        sta     $9412
        lda     #$00
        sta     $9413
        lda     #$00
        sta     $9414
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l009_010        
        lda     #$00
        sta     $9600
        lda     #$00
        sta     $9601
        lda     #$00
        sta     $9602
        lda     #$00
        sta     $9603
        lda     #$00
        sta     $9604
        lda     #$00
        sta     $9605
        lda     #$00
        sta     $9606
        lda     #$00
        sta     $9607
        lda     #$00
        sta     $9608
        lda     #$00
        sta     $9609
        lda     #$00
        sta     $960a
        lda     #$00
        sta     $960b
        lda     #$00
        sta     $960c
        lda     #$00
        sta     $960d
        lda     #$00
        sta     $960e
        lda     #$00
        sta     $960f
        lda     #$00
        sta     $9610
        lda     #$00
        sta     $9611
        lda     #$00
        sta     $9612
        lda     #$00
        sta     $9613
        lda     #$00
        sta     $9614
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l011_012        
        lda     #$00
        sta     $9400
        lda     #$00
        sta     $9401
        lda     #$00
        sta     $9402
        lda     #$00
        sta     $9403
        lda     #$00
        sta     $9404
        lda     #$00
        sta     $9405
        lda     #$00
        sta     $9406
        lda     #$00
        sta     $9407
        lda     #$00
        sta     $9408
        lda     #$00
        sta     $9409
        lda     #$00
        sta     $940a
        lda     #$00
        sta     $940b
        lda     #$00
        sta     $940c
        lda     #$00
        sta     $940d
        lda     #$00
        sta     $940e
        lda     #$00
        sta     $940f
        lda     #$00
        sta     $9410
        lda     #$00
        sta     $9411
        lda     #$00
        sta     $9412
        lda     #$00
        sta     $9413
        lda     #$00
        sta     $9414
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l013_014        
        lda     #$00
        sta     $9600
        lda     #$00
        sta     $9601
        lda     #$00
        sta     $9602
        lda     #$00
        sta     $9603
        lda     #$00
        sta     $9604
        lda     #$00
        sta     $9605
        lda     #$00
        sta     $9606
        lda     #$00
        sta     $9607
        lda     #$00
        sta     $9608
        lda     #$00
        sta     $9609
        lda     #$00
        sta     $960a
        lda     #$00
        sta     $960b
        lda     #$00
        sta     $960c
        lda     #$00
        sta     $960d
        lda     #$00
        sta     $960e
        lda     #$00
        sta     $960f
        lda     #$00
        sta     $9610
        lda     #$00
        sta     $9611
        lda     #$00
        sta     $9612
        lda     #$00
        sta     $9613
        lda     #$00
        sta     $9614
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l015_016        
        lda     #$00
        sta     $9400
        lda     #$00
        sta     $9401
        lda     #$00
        sta     $9402
        lda     #$00
        sta     $9403
        lda     #$00
        sta     $9404
        lda     #$00
        sta     $9405
        lda     #$00
        sta     $9406
        lda     #$00
        sta     $9407
        lda     #$00
        sta     $9408
        lda     #$00
        sta     $9409
        lda     #$00
        sta     $940a
        lda     #$00
        sta     $940b
        lda     #$00
        sta     $940c
        lda     #$00
        sta     $940d
        lda     #$00
        sta     $940e
        lda     #$00
        sta     $940f
        lda     #$00
        sta     $9410
        lda     #$00
        sta     $9411
        lda     #$00
        sta     $9412
        lda     #$00
        sta     $9413
        lda     #$00
        sta     $9414
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l017_018        
        lda     #$00
        sta     $9615
        lda     #$00
        sta     $9616
        lda     #$00
        sta     $9617
        lda     #$00
        sta     $9618
        lda     #$00
        sta     $9619
        lda     #$00
        sta     $961a
        lda     #$00
        sta     $961b
        lda     #$00
        sta     $961c
        lda     #$00
        sta     $961d
        lda     #$00
        sta     $961e
        lda     #$00
        sta     $961f
        lda     #$00
        sta     $9620
        lda     #$00
        sta     $9621
        lda     #$00
        sta     $9622
        lda     #$00
        sta     $9623
        lda     #$00
        sta     $9624
        lda     #$00
        sta     $9625
        lda     #$00
        sta     $9626
        lda     #$00
        sta     $9627
        lda     #$00
        sta     $9628
        lda     #$00
        sta     $9629
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l019_020        
        lda     #$00
        sta     $9415
        lda     #$00
        sta     $9416
        lda     #$00
        sta     $9417
        lda     #$00
        sta     $9418
        lda     #$00
        sta     $9419
        lda     #$00
        sta     $941a
        lda     #$00
        sta     $941b
        lda     #$00
        sta     $941c
        lda     #$00
        sta     $941d
        lda     #$00
        sta     $941e
        lda     #$00
        sta     $941f
        lda     #$00
        sta     $9420
        lda     #$00
        sta     $9421
        lda     #$00
        sta     $9422
        lda     #$00
        sta     $9423
        lda     #$00
        sta     $9424
        lda     #$00
        sta     $9425
        lda     #$00
        sta     $9426
        lda     #$00
        sta     $9427
        lda     #$00
        sta     $9428
        lda     #$00
        sta     $9429
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l021_022        
        lda     #$00
        sta     $9615
        lda     #$00
        sta     $9616
        lda     #$00
        sta     $9617
        lda     #$00
        sta     $9618
        lda     #$00
        sta     $9619
        lda     #$00
        sta     $961a
        lda     #$00
        sta     $961b
        lda     #$00
        sta     $961c
        lda     #$00
        sta     $961d
        lda     #$00
        sta     $961e
        lda     #$00
        sta     $961f
        lda     #$00
        sta     $9620
        lda     #$00
        sta     $9621
        lda     #$00
        sta     $9622
        lda     #$00
        sta     $9623
        lda     #$00
        sta     $9624
        lda     #$00
        sta     $9625
        lda     #$00
        sta     $9626
        lda     #$00
        sta     $9627
        lda     #$00
        sta     $9628
        lda     #$00
        sta     $9629
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002

l023_024        
        lda     #$00
        sta     $9415
        lda     #$00
        sta     $9416
        lda     #$00
        sta     $9417
        lda     #$00
        sta     $9418
        lda     #$00
        sta     $9419
        lda     #$00
        sta     $941a
        lda     #$00
        sta     $941b
        lda     #$00
        sta     $941c
        lda     #$00
        sta     $941d
        lda     #$00
        sta     $941e
        lda     #$00
        sta     $941f
        lda     #$00
        sta     $9420
        lda     #$00
        sta     $9421
        lda     #$00
        sta     $9422
        lda     #$00
        sta     $9423
        lda     #$00
        sta     $9424
        lda     #$00
        sta     $9425
        lda     #$00
        sta     $9426
        lda     #$00
        sta     $9427
        lda     #$00
        sta     $9428
        lda     #$00
        sta     $9429
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002

l025_026        
        lda     #$00
        sta     $9615
        lda     #$00
        sta     $9616
        lda     #$00
        sta     $9617
        lda     #$00
        sta     $9618
        lda     #$00
        sta     $9619
        lda     #$00
        sta     $961a
        lda     #$00
        sta     $961b
        lda     #$00
        sta     $961c
        lda     #$00
        sta     $961d
        lda     #$00
        sta     $961e
        lda     #$00
        sta     $961f
        lda     #$00
        sta     $9620
        lda     #$00
        sta     $9621
        lda     #$00
        sta     $9622
        lda     #$00
        sta     $9623
        lda     #$00
        sta     $9624
        lda     #$00
        sta     $9625
        lda     #$00
        sta     $9626
        lda     #$00
        sta     $9627
        lda     #$00
        sta     $9628
        lda     #$00
        sta     $9629
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l027_028        
        lda     #$00
        sta     $9415
        lda     #$00
        sta     $9416
        lda     #$00
        sta     $9417
        lda     #$00
        sta     $9418
        lda     #$00
        sta     $9419
        lda     #$00
        sta     $941a
        lda     #$00
        sta     $941b
        lda     #$00
        sta     $941c
        lda     #$00
        sta     $941d
        lda     #$00
        sta     $941e
        lda     #$00
        sta     $941f
        lda     #$00
        sta     $9420
        lda     #$00
        sta     $9421
        lda     #$00
        sta     $9422
        lda     #$00
        sta     $9423
        lda     #$00
        sta     $9424
        lda     #$00
        sta     $9425
        lda     #$00
        sta     $9426
        lda     #$00
        sta     $9427
        lda     #$00
        sta     $9428
        lda     #$00
        sta     $9429
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l029_030        
        lda     #$00
        sta     $9615
        lda     #$00
        sta     $9616
        lda     #$00
        sta     $9617
        lda     #$00
        sta     $9618
        lda     #$00
        sta     $9619
        lda     #$00
        sta     $961a
        lda     #$00
        sta     $961b
        lda     #$00
        sta     $961c
        lda     #$00
        sta     $961d
        lda     #$00
        sta     $961e
        lda     #$00
        sta     $961f
        lda     #$00
        sta     $9620
        lda     #$00
        sta     $9621
        lda     #$00
        sta     $9622
        lda     #$00
        sta     $9623
        lda     #$00
        sta     $9624
        lda     #$00
        sta     $9625
        lda     #$00
        sta     $9626
        lda     #$00
        sta     $9627
        lda     #$00
        sta     $9628
        lda     #$00
        sta     $9629
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l031_032        
        lda     #$00
        sta     $9415
        lda     #$00
        sta     $9416
        lda     #$00
        sta     $9417
        lda     #$00
        sta     $9418
        lda     #$00
        sta     $9419
        lda     #$00
        sta     $941a
        lda     #$00
        sta     $941b
        lda     #$00
        sta     $941c
        lda     #$00
        sta     $941d
        lda     #$00
        sta     $941e
        lda     #$00
        sta     $941f
        lda     #$00
        sta     $9420
        lda     #$00
        sta     $9421
        lda     #$00
        sta     $9422
        lda     #$00
        sta     $9423
        lda     #$00
        sta     $9424
        lda     #$00
        sta     $9425
        lda     #$00
        sta     $9426
        lda     #$00
        sta     $9427
        lda     #$00
        sta     $9428
        lda     #$00
        sta     $9429
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l033_034        
        lda     #$00
        sta     $962a
        lda     #$00
        sta     $962b
        lda     #$00
        sta     $962c
        lda     #$00
        sta     $962d
        lda     #$00
        sta     $962e
        lda     #$00
        sta     $962f
        lda     #$00
        sta     $9630
        lda     #$00
        sta     $9631
        lda     #$00
        sta     $9632
        lda     #$00
        sta     $9633
        lda     #$00
        sta     $9634
        lda     #$00
        sta     $9635
        lda     #$00
        sta     $9636
        lda     #$00
        sta     $9637
        lda     #$00
        sta     $9638
        lda     #$00
        sta     $9639
        lda     #$00
        sta     $963a
        lda     #$00
        sta     $963b
        lda     #$00
        sta     $963c
        lda     #$00
        sta     $963d
        lda     #$00
        sta     $963e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l035_036        
        lda     #$00
        sta     $942a
        lda     #$00
        sta     $942b
        lda     #$00
        sta     $942c
        lda     #$00
        sta     $942d
        lda     #$00
        sta     $942e
        lda     #$00
        sta     $942f
        lda     #$00
        sta     $9430
        lda     #$00
        sta     $9431
        lda     #$00
        sta     $9432
        lda     #$00
        sta     $9433
        lda     #$00
        sta     $9434
        lda     #$00
        sta     $9435
        lda     #$00
        sta     $9436
        lda     #$00
        sta     $9437
        lda     #$00
        sta     $9438
        lda     #$00
        sta     $9439
        lda     #$00
        sta     $943a
        lda     #$00
        sta     $943b
        lda     #$00
        sta     $943c
        lda     #$00
        sta     $943d
        lda     #$00
        sta     $943e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l037_038        
        lda     #$00
        sta     $962a
        lda     #$00
        sta     $962b
        lda     #$00
        sta     $962c
        lda     #$00
        sta     $962d
        lda     #$00
        sta     $962e
        lda     #$00
        sta     $962f
        lda     #$00
        sta     $9630
        lda     #$00
        sta     $9631
        lda     #$00
        sta     $9632
        lda     #$00
        sta     $9633
        lda     #$00
        sta     $9634
        lda     #$00
        sta     $9635
        lda     #$00
        sta     $9636
        lda     #$00
        sta     $9637
        lda     #$00
        sta     $9638
        lda     #$00
        sta     $9639
        lda     #$00
        sta     $963a
        lda     #$00
        sta     $963b
        lda     #$00
        sta     $963c
        lda     #$00
        sta     $963d
        lda     #$00
        sta     $963e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l039_040        
        lda     #$00
        sta     $942a
        lda     #$00
        sta     $942b
        lda     #$00
        sta     $942c
        lda     #$00
        sta     $942d
        lda     #$00
        sta     $942e
        lda     #$00
        sta     $942f
        lda     #$00
        sta     $9430
        lda     #$00
        sta     $9431
        lda     #$00
        sta     $9432
        lda     #$00
        sta     $9433
        lda     #$00
        sta     $9434
        lda     #$00
        sta     $9435
        lda     #$00
        sta     $9436
        lda     #$00
        sta     $9437
        lda     #$00
        sta     $9438
        lda     #$00
        sta     $9439
        lda     #$00
        sta     $943a
        lda     #$00
        sta     $943b
        lda     #$00
        sta     $943c
        lda     #$00
        sta     $943d
        lda     #$00
        sta     $943e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l041_042        
        lda     #$00
        sta     $962a
        lda     #$00
        sta     $962b
        lda     #$00
        sta     $962c
        lda     #$00
        sta     $962d
        lda     #$00
        sta     $962e
        lda     #$00
        sta     $962f
        lda     #$00
        sta     $9630
        lda     #$00
        sta     $9631
        lda     #$00
        sta     $9632
        lda     #$00
        sta     $9633
        lda     #$00
        sta     $9634
        lda     #$00
        sta     $9635
        lda     #$00
        sta     $9636
        lda     #$00
        sta     $9637
        lda     #$00
        sta     $9638
        lda     #$00
        sta     $9639
        lda     #$00
        sta     $963a
        lda     #$00
        sta     $963b
        lda     #$00
        sta     $963c
        lda     #$00
        sta     $963d
        lda     #$00
        sta     $963e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l043_044        
        lda     #$00
        sta     $942a
        lda     #$00
        sta     $942b
        lda     #$00
        sta     $942c
        lda     #$00
        sta     $942d
        lda     #$00
        sta     $942e
        lda     #$00
        sta     $942f
        lda     #$00
        sta     $9430
        lda     #$00
        sta     $9431
        lda     #$00
        sta     $9432
        lda     #$00
        sta     $9433
        lda     #$00
        sta     $9434
        lda     #$00
        sta     $9435
        lda     #$00
        sta     $9436
        lda     #$00
        sta     $9437
        lda     #$00
        sta     $9438
        lda     #$00
        sta     $9439
        lda     #$00
        sta     $943a
        lda     #$00
        sta     $943b
        lda     #$00
        sta     $943c
        lda     #$00
        sta     $943d
        lda     #$00
        sta     $943e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l045_046        
        lda     #$00
        sta     $962a
        lda     #$00
        sta     $962b
        lda     #$00
        sta     $962c
        lda     #$00
        sta     $962d
        lda     #$00
        sta     $962e
        lda     #$00
        sta     $962f
        lda     #$00
        sta     $9630
        lda     #$00
        sta     $9631
        lda     #$00
        sta     $9632
        lda     #$00
        sta     $9633
        lda     #$00
        sta     $9634
        lda     #$00
        sta     $9635
        lda     #$00
        sta     $9636
        lda     #$00
        sta     $9637
        lda     #$00
        sta     $9638
        lda     #$00
        sta     $9639
        lda     #$00
        sta     $963a
        lda     #$00
        sta     $963b
        lda     #$00
        sta     $963c
        lda     #$00
        sta     $963d
        lda     #$00
        sta     $963e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l047_048        
        lda     #$00
        sta     $942a
        lda     #$00
        sta     $942b
        lda     #$00
        sta     $942c
        lda     #$00
        sta     $942d
        lda     #$00
        sta     $942e
        lda     #$00
        sta     $942f
        lda     #$00
        sta     $9430
        lda     #$00
        sta     $9431
        lda     #$00
        sta     $9432
        lda     #$00
        sta     $9433
        lda     #$00
        sta     $9434
        lda     #$00
        sta     $9435
        lda     #$00
        sta     $9436
        lda     #$00
        sta     $9437
        lda     #$00
        sta     $9438
        lda     #$00
        sta     $9439
        lda     #$00
        sta     $943a
        lda     #$00
        sta     $943b
        lda     #$00
        sta     $943c
        lda     #$00
        sta     $943d
        lda     #$00
        sta     $943e
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l049_050        
        lda     #$00
        sta     $963f
        lda     #$00
        sta     $9640
        lda     #$00
        sta     $9641
        lda     #$00
        sta     $9642
        lda     #$00
        sta     $9643
        lda     #$00
        sta     $9644
        lda     #$00
        sta     $9645
        lda     #$00
        sta     $9646
        lda     #$00
        sta     $9647
        lda     #$00
        sta     $9648
        lda     #$00
        sta     $9649
        lda     #$00
        sta     $964a
        lda     #$00
        sta     $964b
        lda     #$00
        sta     $964c
        lda     #$00
        sta     $964d
        lda     #$00
        sta     $964e
        lda     #$00
        sta     $964f
        lda     #$00
        sta     $9650
        lda     #$00
        sta     $9651
        lda     #$00
        sta     $9652
        lda     #$00
        sta     $9653
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l051_052        
        lda     #$00
        sta     $943f
        lda     #$00
        sta     $9440
        lda     #$00
        sta     $9441
        lda     #$00
        sta     $9442
        lda     #$00
        sta     $9443
        lda     #$00
        sta     $9444
        lda     #$00
        sta     $9445
        lda     #$00
        sta     $9446
        lda     #$00
        sta     $9447
        lda     #$00
        sta     $9448
        lda     #$00
        sta     $9449
        lda     #$00
        sta     $944a
        lda     #$00
        sta     $944b
        lda     #$00
        sta     $944c
        lda     #$00
        sta     $944d
        lda     #$00
        sta     $944e
        lda     #$00
        sta     $944f
        lda     #$00
        sta     $9450
        lda     #$00
        sta     $9451
        lda     #$00
        sta     $9452
        lda     #$00
        sta     $9453
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l053_054        
        lda     #$00
        sta     $963f
        lda     #$00
        sta     $9640
        lda     #$00
        sta     $9641
        lda     #$00
        sta     $9642
        lda     #$00
        sta     $9643
        lda     #$00
        sta     $9644
        lda     #$00
        sta     $9645
        lda     #$00
        sta     $9646
        lda     #$00
        sta     $9647
        lda     #$00
        sta     $9648
        lda     #$00
        sta     $9649
        lda     #$00
        sta     $964a
        lda     #$00
        sta     $964b
        lda     #$00
        sta     $964c
        lda     #$00
        sta     $964d
        lda     #$00
        sta     $964e
        lda     #$00
        sta     $964f
        lda     #$00
        sta     $9650
        lda     #$00
        sta     $9651
        lda     #$00
        sta     $9652
        lda     #$00
        sta     $9653
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l055_056        
        lda     #$00
        sta     $943f
        lda     #$00
        sta     $9440
        lda     #$00
        sta     $9441
        lda     #$00
        sta     $9442
        lda     #$00
        sta     $9443
        lda     #$00
        sta     $9444
        lda     #$00
        sta     $9445
        lda     #$00
        sta     $9446
        lda     #$00
        sta     $9447
        lda     #$00
        sta     $9448
        lda     #$00
        sta     $9449
        lda     #$00
        sta     $944a
        lda     #$00
        sta     $944b
        lda     #$00
        sta     $944c
        lda     #$00
        sta     $944d
        lda     #$00
        sta     $944e
        lda     #$00
        sta     $944f
        lda     #$00
        sta     $9450
        lda     #$00
        sta     $9451
        lda     #$00
        sta     $9452
        lda     #$00
        sta     $9453
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l057_058        
        lda     #$00
        sta     $963f
        lda     #$00
        sta     $9640
        lda     #$00
        sta     $9641
        lda     #$00
        sta     $9642
        lda     #$00
        sta     $9643
        lda     #$00
        sta     $9644
        lda     #$00
        sta     $9645
        lda     #$00
        sta     $9646
        lda     #$00
        sta     $9647
        lda     #$00
        sta     $9648
        lda     #$00
        sta     $9649
        lda     #$00
        sta     $964a
        lda     #$00
        sta     $964b
        lda     #$00
        sta     $964c
        lda     #$00
        sta     $964d
        lda     #$00
        sta     $964e
        lda     #$00
        sta     $964f
        lda     #$00
        sta     $9650
        lda     #$00
        sta     $9651
        lda     #$00
        sta     $9652
        lda     #$00
        sta     $9653
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l059_060        
        lda     #$00
        sta     $943f
        lda     #$00
        sta     $9440
        lda     #$00
        sta     $9441
        lda     #$00
        sta     $9442
        lda     #$00
        sta     $9443
        lda     #$00
        sta     $9444
        lda     #$00
        sta     $9445
        lda     #$00
        sta     $9446
        lda     #$00
        sta     $9447
        lda     #$00
        sta     $9448
        lda     #$00
        sta     $9449
        lda     #$00
        sta     $944a
        lda     #$00
        sta     $944b
        lda     #$00
        sta     $944c
        lda     #$00
        sta     $944d
        lda     #$00
        sta     $944e
        lda     #$00
        sta     $944f
        lda     #$00
        sta     $9450
        lda     #$00
        sta     $9451
        lda     #$00
        sta     $9452
        lda     #$00
        sta     $9453
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l061_062        
        lda     #$00
        sta     $963f
        lda     #$00
        sta     $9640
        lda     #$00
        sta     $9641
        lda     #$00
        sta     $9642
        lda     #$00
        sta     $9643
        lda     #$00
        sta     $9644
        lda     #$00
        sta     $9645
        lda     #$00
        sta     $9646
        lda     #$00
        sta     $9647
        lda     #$00
        sta     $9648
        lda     #$00
        sta     $9649
        lda     #$00
        sta     $964a
        lda     #$00
        sta     $964b
        lda     #$00
        sta     $964c
        lda     #$00
        sta     $964d
        lda     #$00
        sta     $964e
        lda     #$00
        sta     $964f
        lda     #$00
        sta     $9650
        lda     #$00
        sta     $9651
        lda     #$00
        sta     $9652
        lda     #$00
        sta     $9653
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l063_064        
        lda     #$00
        sta     $943f
        lda     #$00
        sta     $9440
        lda     #$00
        sta     $9441
        lda     #$00
        sta     $9442
        lda     #$00
        sta     $9443
        lda     #$00
        sta     $9444
        lda     #$00
        sta     $9445
        lda     #$00
        sta     $9446
        lda     #$00
        sta     $9447
        lda     #$00
        sta     $9448
        lda     #$00
        sta     $9449
        lda     #$00
        sta     $944a
        lda     #$00
        sta     $944b
        lda     #$00
        sta     $944c
        lda     #$00
        sta     $944d
        lda     #$00
        sta     $944e
        lda     #$00
        sta     $944f
        lda     #$00
        sta     $9450
        lda     #$00
        sta     $9451
        lda     #$00
        sta     $9452
        lda     #$00
        sta     $9453
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l065_066        
        lda     #$00
        sta     $9654
        lda     #$00
        sta     $9655
        lda     #$00
        sta     $9656
        lda     #$00
        sta     $9657
        lda     #$00
        sta     $9658
        lda     #$00
        sta     $9659
        lda     #$00
        sta     $965a
        lda     #$00
        sta     $965b
        lda     #$00
        sta     $965c
        lda     #$00
        sta     $965d
        lda     #$00
        sta     $965e
        lda     #$00
        sta     $965f
        lda     #$00
        sta     $9660
        lda     #$00
        sta     $9661
        lda     #$00
        sta     $9662
        lda     #$00
        sta     $9663
        lda     #$00
        sta     $9664
        lda     #$00
        sta     $9665
        lda     #$00
        sta     $9666
        lda     #$00
        sta     $9667
        lda     #$00
        sta     $9668
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l067_068        
        lda     #$00
        sta     $9454
        lda     #$00
        sta     $9455
        lda     #$00
        sta     $9456
        lda     #$00
        sta     $9457
        lda     #$00
        sta     $9458
        lda     #$00
        sta     $9459
        lda     #$00
        sta     $945a
        lda     #$00
        sta     $945b
        lda     #$00
        sta     $945c
        lda     #$00
        sta     $945d
        lda     #$00
        sta     $945e
        lda     #$00
        sta     $945f
        lda     #$00
        sta     $9460
        lda     #$00
        sta     $9461
        lda     #$00
        sta     $9462
        lda     #$00
        sta     $9463
        lda     #$00
        sta     $9464
        lda     #$00
        sta     $9465
        lda     #$00
        sta     $9466
        lda     #$00
        sta     $9467
        lda     #$00
        sta     $9468
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l069_070        
        lda     #$00
        sta     $9654
        lda     #$00
        sta     $9655
        lda     #$00
        sta     $9656
        lda     #$00
        sta     $9657
        lda     #$00
        sta     $9658
        lda     #$00
        sta     $9659
        lda     #$00
        sta     $965a
        lda     #$00
        sta     $965b
        lda     #$00
        sta     $965c
        lda     #$00
        sta     $965d
        lda     #$00
        sta     $965e
        lda     #$00
        sta     $965f
        lda     #$00
        sta     $9660
        lda     #$00
        sta     $9661
        lda     #$00
        sta     $9662
        lda     #$00
        sta     $9663
        lda     #$00
        sta     $9664
        lda     #$00
        sta     $9665
        lda     #$00
        sta     $9666
        lda     #$00
        sta     $9667
        lda     #$00
        sta     $9668
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l071_072        
        lda     #$00
        sta     $9454
        lda     #$00
        sta     $9455
        lda     #$00
        sta     $9456
        lda     #$00
        sta     $9457
        lda     #$00
        sta     $9458
        lda     #$00
        sta     $9459
        lda     #$00
        sta     $945a
        lda     #$00
        sta     $945b
        lda     #$00
        sta     $945c
        lda     #$00
        sta     $945d
        lda     #$00
        sta     $945e
        lda     #$00
        sta     $945f
        lda     #$00
        sta     $9460
        lda     #$00
        sta     $9461
        lda     #$00
        sta     $9462
        lda     #$00
        sta     $9463
        lda     #$00
        sta     $9464
        lda     #$00
        sta     $9465
        lda     #$00
        sta     $9466
        lda     #$00
        sta     $9467
        lda     #$00
        sta     $9468
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l073_074        
        lda     #$00
        sta     $9654
        lda     #$00
        sta     $9655
        lda     #$00
        sta     $9656
        lda     #$00
        sta     $9657
        lda     #$00
        sta     $9658
        lda     #$00
        sta     $9659
        lda     #$00
        sta     $965a
        lda     #$00
        sta     $965b
        lda     #$00
        sta     $965c
        lda     #$00
        sta     $965d
        lda     #$00
        sta     $965e
        lda     #$00
        sta     $965f
        lda     #$00
        sta     $9660
        lda     #$00
        sta     $9661
        lda     #$00
        sta     $9662
        lda     #$00
        sta     $9663
        lda     #$00
        sta     $9664
        lda     #$00
        sta     $9665
        lda     #$00
        sta     $9666
        lda     #$00
        sta     $9667
        lda     #$00
        sta     $9668
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l075_076        
        lda     #$00
        sta     $9454
        lda     #$00
        sta     $9455
        lda     #$00
        sta     $9456
        lda     #$00
        sta     $9457
        lda     #$00
        sta     $9458
        lda     #$00
        sta     $9459
        lda     #$00
        sta     $945a
        lda     #$00
        sta     $945b
        lda     #$00
        sta     $945c
        lda     #$00
        sta     $945d
        lda     #$00
        sta     $945e
        lda     #$00
        sta     $945f
        lda     #$00
        sta     $9460
        lda     #$00
        sta     $9461
        lda     #$00
        sta     $9462
        lda     #$00
        sta     $9463
        lda     #$00
        sta     $9464
        lda     #$00
        sta     $9465
        lda     #$00
        sta     $9466
        lda     #$00
        sta     $9467
        lda     #$00
        sta     $9468
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l077_078        
        lda     #$00
        sta     $9654
        lda     #$00
        sta     $9655
        lda     #$00
        sta     $9656
        lda     #$00
        sta     $9657
        lda     #$00
        sta     $9658
        lda     #$00
        sta     $9659
        lda     #$00
        sta     $965a
        lda     #$00
        sta     $965b
        lda     #$00
        sta     $965c
        lda     #$00
        sta     $965d
        lda     #$00
        sta     $965e
        lda     #$00
        sta     $965f
        lda     #$00
        sta     $9660
        lda     #$00
        sta     $9661
        lda     #$00
        sta     $9662
        lda     #$00
        sta     $9663
        lda     #$00
        sta     $9664
        lda     #$00
        sta     $9665
        lda     #$00
        sta     $9666
        lda     #$00
        sta     $9667
        lda     #$00
        sta     $9668
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l079_080        
        lda     #$00
        sta     $9454
        lda     #$00
        sta     $9455
        lda     #$00
        sta     $9456
        lda     #$00
        sta     $9457
        lda     #$00
        sta     $9458
        lda     #$00
        sta     $9459
        lda     #$00
        sta     $945a
        lda     #$00
        sta     $945b
        lda     #$00
        sta     $945c
        lda     #$00
        sta     $945d
        lda     #$00
        sta     $945e
        lda     #$00
        sta     $945f
        lda     #$00
        sta     $9460
        lda     #$00
        sta     $9461
        lda     #$00
        sta     $9462
        lda     #$00
        sta     $9463
        lda     #$00
        sta     $9464
        lda     #$00
        sta     $9465
        lda     #$00
        sta     $9466
        lda     #$00
        sta     $9467
        lda     #$00
        sta     $9468
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l081_082        
        lda     #$00
        sta     $9669
        lda     #$00
        sta     $966a
        lda     #$00
        sta     $966b
        lda     #$00
        sta     $966c
        lda     #$00
        sta     $966d
        lda     #$00
        sta     $966e
        lda     #$00
        sta     $966f
        lda     #$00
        sta     $9670
        lda     #$00
        sta     $9671
        lda     #$00
        sta     $9672
        lda     #$00
        sta     $9673
        lda     #$00
        sta     $9674
        lda     #$00
        sta     $9675
        lda     #$00
        sta     $9676
        lda     #$00
        sta     $9677
        lda     #$00
        sta     $9678
        lda     #$00
        sta     $9679
        lda     #$00
        sta     $967a
        lda     #$00
        sta     $967b
        lda     #$00
        sta     $967c
        lda     #$00
        sta     $967d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l083_084        
        lda     #$00
        sta     $9469
        lda     #$00
        sta     $946a
        lda     #$00
        sta     $946b
        lda     #$00
        sta     $946c
        lda     #$00
        sta     $946d
        lda     #$00
        sta     $946e
        lda     #$00
        sta     $946f
        lda     #$00
        sta     $9470
        lda     #$00
        sta     $9471
        lda     #$00
        sta     $9472
        lda     #$00
        sta     $9473
        lda     #$00
        sta     $9474
        lda     #$00
        sta     $9475
        lda     #$00
        sta     $9476
        lda     #$00
        sta     $9477
        lda     #$00
        sta     $9478
        lda     #$00
        sta     $9479
        lda     #$00
        sta     $947a
        lda     #$00
        sta     $947b
        lda     #$00
        sta     $947c
        lda     #$00
        sta     $947d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l085_086        
        lda     #$00
        sta     $9669
        lda     #$00
        sta     $966a
        lda     #$00
        sta     $966b
        lda     #$00
        sta     $966c
        lda     #$00
        sta     $966d
        lda     #$00
        sta     $966e
        lda     #$00
        sta     $966f
        lda     #$00
        sta     $9670
        lda     #$00
        sta     $9671
        lda     #$00
        sta     $9672
        lda     #$00
        sta     $9673
        lda     #$00
        sta     $9674
        lda     #$00
        sta     $9675
        lda     #$00
        sta     $9676
        lda     #$00
        sta     $9677
        lda     #$00
        sta     $9678
        lda     #$00
        sta     $9679
        lda     #$00
        sta     $967a
        lda     #$00
        sta     $967b
        lda     #$00
        sta     $967c
        lda     #$00
        sta     $967d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l087_088        
        lda     #$00
        sta     $9469
        lda     #$00
        sta     $946a
        lda     #$00
        sta     $946b
        lda     #$00
        sta     $946c
        lda     #$00
        sta     $946d
        lda     #$00
        sta     $946e
        lda     #$00
        sta     $946f
        lda     #$00
        sta     $9470
        lda     #$00
        sta     $9471
        lda     #$00
        sta     $9472
        lda     #$00
        sta     $9473
        lda     #$00
        sta     $9474
        lda     #$00
        sta     $9475
        lda     #$00
        sta     $9476
        lda     #$00
        sta     $9477
        lda     #$00
        sta     $9478
        lda     #$00
        sta     $9479
        lda     #$00
        sta     $947a
        lda     #$00
        sta     $947b
        lda     #$00
        sta     $947c
        lda     #$00
        sta     $947d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l089_090        
        lda     #$00
        sta     $9669
        lda     #$00
        sta     $966a
        lda     #$00
        sta     $966b
        lda     #$00
        sta     $966c
        lda     #$00
        sta     $966d
        lda     #$00
        sta     $966e
        lda     #$00
        sta     $966f
        lda     #$00
        sta     $9670
        lda     #$00
        sta     $9671
        lda     #$00
        sta     $9672
        lda     #$00
        sta     $9673
        lda     #$00
        sta     $9674
        lda     #$00
        sta     $9675
        lda     #$00
        sta     $9676
        lda     #$00
        sta     $9677
        lda     #$00
        sta     $9678
        lda     #$00
        sta     $9679
        lda     #$00
        sta     $967a
        lda     #$00
        sta     $967b
        lda     #$00
        sta     $967c
        lda     #$00
        sta     $967d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l091_092        
        lda     #$00
        sta     $9469
        lda     #$00
        sta     $946a
        lda     #$00
        sta     $946b
        lda     #$00
        sta     $946c
        lda     #$00
        sta     $946d
        lda     #$00
        sta     $946e
        lda     #$00
        sta     $946f
        lda     #$00
        sta     $9470
        lda     #$00
        sta     $9471
        lda     #$00
        sta     $9472
        lda     #$00
        sta     $9473
        lda     #$00
        sta     $9474
        lda     #$00
        sta     $9475
        lda     #$00
        sta     $9476
        lda     #$00
        sta     $9477
        lda     #$00
        sta     $9478
        lda     #$00
        sta     $9479
        lda     #$00
        sta     $947a
        lda     #$00
        sta     $947b
        lda     #$00
        sta     $947c
        lda     #$00
        sta     $947d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l093_094        
        lda     #$00
        sta     $9669
        lda     #$00
        sta     $966a
        lda     #$00
        sta     $966b
        lda     #$00
        sta     $966c
        lda     #$00
        sta     $966d
        lda     #$00
        sta     $966e
        lda     #$00
        sta     $966f
        lda     #$00
        sta     $9670
        lda     #$00
        sta     $9671
        lda     #$00
        sta     $9672
        lda     #$00
        sta     $9673
        lda     #$00
        sta     $9674
        lda     #$00
        sta     $9675
        lda     #$00
        sta     $9676
        lda     #$00
        sta     $9677
        lda     #$00
        sta     $9678
        lda     #$00
        sta     $9679
        lda     #$00
        sta     $967a
        lda     #$00
        sta     $967b
        lda     #$00
        sta     $967c
        lda     #$00
        sta     $967d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l095_096        
        lda     #$00
        sta     $9469
        lda     #$00
        sta     $946a
        lda     #$00
        sta     $946b
        lda     #$00
        sta     $946c
        lda     #$00
        sta     $946d
        lda     #$00
        sta     $946e
        lda     #$00
        sta     $946f
        lda     #$00
        sta     $9470
        lda     #$00
        sta     $9471
        lda     #$00
        sta     $9472
        lda     #$00
        sta     $9473
        lda     #$00
        sta     $9474
        lda     #$00
        sta     $9475
        lda     #$00
        sta     $9476
        lda     #$00
        sta     $9477
        lda     #$00
        sta     $9478
        lda     #$00
        sta     $9479
        lda     #$00
        sta     $947a
        lda     #$00
        sta     $947b
        lda     #$00
        sta     $947c
        lda     #$00
        sta     $947d
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l097_098        
        lda     #$00
        sta     $967e
        lda     #$00
        sta     $967f
        lda     #$00
        sta     $9680
        lda     #$00
        sta     $9681
        lda     #$00
        sta     $9682
        lda     #$00
        sta     $9683
        lda     #$00
        sta     $9684
        lda     #$00
        sta     $9685
        lda     #$00
        sta     $9686
        lda     #$00
        sta     $9687
        lda     #$00
        sta     $9688
        lda     #$00
        sta     $9689
        lda     #$00
        sta     $968a
        lda     #$00
        sta     $968b
        lda     #$00
        sta     $968c
        lda     #$00
        sta     $968d
        lda     #$00
        sta     $968e
        lda     #$00
        sta     $968f
        lda     #$00
        sta     $9690
        lda     #$00
        sta     $9691
        lda     #$00
        sta     $9692
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l099_100        
        lda     #$00
        sta     $947e
        lda     #$00
        sta     $947f
        lda     #$00
        sta     $9480
        lda     #$00
        sta     $9481
        lda     #$00
        sta     $9482
        lda     #$00
        sta     $9483
        lda     #$00
        sta     $9484
        lda     #$00
        sta     $9485
        lda     #$00
        sta     $9486
        lda     #$00
        sta     $9487
        lda     #$00
        sta     $9488
        lda     #$00
        sta     $9489
        lda     #$00
        sta     $948a
        lda     #$00
        sta     $948b
        lda     #$00
        sta     $948c
        lda     #$00
        sta     $948d
        lda     #$00
        sta     $948e
        lda     #$00
        sta     $948f
        lda     #$00
        sta     $9490
        lda     #$00
        sta     $9491
        lda     #$00
        sta     $9492
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
                
l101_102        
        lda     #$00
        sta     $967e
        lda     #$00
        sta     $967f
        lda     #$00
        sta     $9680
        lda     #$00
        sta     $9681
        lda     #$00
        sta     $9682
        lda     #$00
        sta     $9683
        lda     #$00
        sta     $9684
        lda     #$00
        sta     $9685
        lda     #$00
        sta     $9686
        lda     #$00
        sta     $9687
        lda     #$00
        sta     $9688
        lda     #$00
        sta     $9689
        lda     #$00
        sta     $968a
        lda     #$00
        sta     $968b
        lda     #$00
        sta     $968c
        lda     #$00
        sta     $968d
        lda     #$00
        sta     $968e
        lda     #$00
        sta     $968f
        lda     #$00
        sta     $9690
        lda     #$00
        sta     $9691
        lda     #$00
        sta     $9692
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l103_104        
        lda     #$00
        sta     $947e
        lda     #$00
        sta     $947f
        lda     #$00
        sta     $9480
        lda     #$00
        sta     $9481
        lda     #$00
        sta     $9482
        lda     #$00
        sta     $9483
        lda     #$00
        sta     $9484
        lda     #$00
        sta     $9485
        lda     #$00
        sta     $9486
        lda     #$00
        sta     $9487
        lda     #$00
        sta     $9488
        lda     #$00
        sta     $9489
        lda     #$00
        sta     $948a
        lda     #$00
        sta     $948b
        lda     #$00
        sta     $948c
        lda     #$00
        sta     $948d
        lda     #$00
        sta     $948e
        lda     #$00
        sta     $948f
        lda     #$00
        sta     $9490
        lda     #$00
        sta     $9491
        lda     #$00
        sta     $9492
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
l105_106        
        lda     #$00
        sta     $967e
        lda     #$00
        sta     $967f
        lda     #$00
        sta     $9680
        lda     #$00
        sta     $9681
        lda     #$00
        sta     $9682
        lda     #$00
        sta     $9683
        lda     #$00
        sta     $9684
        lda     #$00
        sta     $9685
        lda     #$00
        sta     $9686
        lda     #$00
        sta     $9687
        lda     #$00
        sta     $9688
        lda     #$00
        sta     $9689
        lda     #$00
        sta     $968a
        lda     #$00
        sta     $968b
        lda     #$00
        sta     $968c
        lda     #$00
        sta     $968d
        lda     #$00
        sta     $968e
        lda     #$00
        sta     $968f
        lda     #$00
        sta     $9690
        lda     #$00
        sta     $9691
        lda     #$00
        sta     $9692
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        stx     $9002
        
l107_108        
        lda     #$00
        sta     $947e
        lda     #$00
        sta     $947f
        lda     #$00
        sta     $9480
        lda     #$00
        sta     $9481
        lda     #$00
        sta     $9482
        lda     #$00
        sta     $9483
        lda     #$00
        sta     $9484
        lda     #$00
        sta     $9485
        lda     #$00
        sta     $9486
        lda     #$00
        sta     $9487
        lda     #$00
        sta     $9488
        lda     #$00
        sta     $9489
        lda     #$00
        sta     $948a
        lda     #$00
        sta     $948b
        lda     #$00
        sta     $948c
        lda     #$00
        sta     $948d
        lda     #$00
        sta     $948e
        lda     #$00
        sta     $948f
        lda     #$00
        sta     $9490
        lda     #$00
        sta     $9491
        lda     #$00
        sta     $9492
        lda     #$00
        sta     $900e
        lda     #$1b
        sta     $900f
        sty     $9002
        
        jmp     $0400

lbl_bfa9
        ldx     #$15
wait1   dex
        bne     wait1

        lda     #$09
        sta     $9000
        lda     #$19
        sta     $9002
        lda     #$2a    ; switch back to 8x8-mode
        sta     $9003
        pla
        sta     $900f   ; set-color for 8x8-mode
        pla
        sta     $9005   ; switch to normal charset
        jmp     $eabf   ; return to normal IRQ
